<?
// Convert hexadecimal colour codes to RGB
function hex2rgb($hexVal = "") {
	// remove non-valid characters
	$hexVal = eregi_replace("[^a-fA-F0-9]", "", $hexVal);
	// iof the input is not a valid HEX colour code
	if (strlen($hexVal) != 6) { 
		// stop processing
		die("Error: Incorrect colorcode, expecting 6 chars (A-F, 0-9)");
	}
	$arrTmp = explode(" ", chunk_split($hexVal, 2, " "));
	$arrTmp = array_map("hexdec", $arrTmp);
	// return the RGB colour code as an array
	return array("red" => $arrTmp[0], "green" => $arrTmp[1], "blue" => $arrTmp[2]);
} 

// start the Aire function
function aire($width, $height, $text, $alignment, $bgcolor, $bgtransparency, $fontcolor, $ttfont, $fontsize, $riser, $path, $overwrite,$output="image"){

/*
If you are using Windows please leave the next two lines commented out, you can then
use any font installed on the Windows system you run this function on. Otherwise
leave this as is as this sets the enviroment variable for GD to the fonts folder
provided with the Aire function. The fonts you get by default are:

Airstream_ITC_TT.ttf		53 k
Alexandria.ttf			41 k
Antique_Type.ttf			104 k
Arizona.ttf				38 k
Balmoral_D.ttf			75 k
Bell_Gothic_Black.ttf		70 k
ChocolateBox.ttf			30 k
Curlz_MT.ttf				69 k
Kids.ttf				53 k
Linotype_Aroma.ttf			42 k
Perpetua.ttf				49 k
Pricedown.ttf				18 k
Soubrette.ttf				85 k
Tempus_Sans_ITC.ttf		77 k

These fonts are all available from http://www.goodfonts.org/, with many more good
free fonts. Use the file names as given in the brackets above to use any of these fonts.
*/
// set the environment font path for the GD image function to the fonts folder
putenv('GDFONTPATH=' . realpath('fonts/'));
// remove the .ttf extension from the font filename
$ttfont = str_replace(".ttf","",$ttfont);

	// create the file name based on the text inputted
	$filename = str_replace(" ","-",strtolower($text));
	$filename = eregi_replace("[^-a-z0-9]", "", $filename);
	$imgname = $path."/";
	$imgname .= "$filename.png";

	// if the image does not exists, or overwrite is set to 1, then run the image creation code
	if (!file_exists($imgname) || $overwrite=1){
	
		// create the image at the requested size
		$im = @imagecreate($width, $height)
			// if there's been a problem, stop processing
			or die("Cannot initialize new GD image stream");
			
		// if the background colour entered is less than 7 characters, i.e. a HEX colour code, convert it to RGB
		if (strlen($bgcolor)<7){
			$bgcolor = hex2rgb($bgcolor);
		// otherwise use the RGB colour code
		} else {
			$arrTmp = explode(",",$bgcolor);
			$bgcolor = array("red" => $arrTmp[0], "green" => $arrTmp[1], "blue" => $arrTmp[2]);
		}
		
		// if the font colour entered is less than 7 characters, i.e. a HEX colour code, convert it to RGB
		if (strlen($fontcolor)<7){
			$fontcolor = hex2rgb($fontcolor);
		// otherwise use the RGB colour code
		} else {
			$arrTmp = explode(",",$fontcolor);
			$fontcolor = array("red" => $arrTmp[0], "green" => $arrTmp[1], "blue" => $arrTmp[2]);
		}
		
		// if the alignment is not set correctly then set the alignment to left
		if($alignment!="left" && $alignment!="center" && $alignment!="right"){
			$alignment="left";
		}
		
		// see whether the image background should be transparent
		if ($bgtransparency==0){
			// create an image with a background colour as specified
			$background = ImageColorAllocate($im, $bgcolor[red], $bgcolor[green], $bgcolor[blue]);
		} else {
			// else create an image with a transparent background
			$background = ImageColorAllocateAlpha($im, $bgcolor[red], $bgcolor[green], $bgcolor[blue], $bgtransparency);
		}
		// fill in the background
		ImageFilledRectangle($im, 0, 0, $width, $height, $background);

		// set the font colour
		$fontcolor = imagecolorallocate($im, $fontcolor[red], $fontcolor[green], $fontcolor[blue]);
		
		// check that the user has selected a font
		if ($ttfont==""){
			// output the standard text
			$output = "text";
		} else {
			// create the text string with the selected True Type font
			if (@!imagettftext($im, $fontsize, 0, 0, ($height-7), $fontcolor, $ttfont, "$text")){
			// if there is a problem, for example the font cannot be found, just output the standard text
			$output = "text";
			}
		}
		// save the image
		imagepng($im, $imgname);
		// destroy the image
		imagedestroy($im);
	}
	
	// if there has been an error, just output the text
	if($output=="text"){
		$return = "<div style=\"text-align: $alignment;\">$text ($error)</div>";
	// otherwise show the full inline CSS and image
	} else {
                $return = "<span style=\"";
		$return .= "display: block;";
		$return .= "text-indent: -100em;";
		$return .= "overflow: hidden;";
		$return .= "line-height: ".$height."px;";
		$return .= "background: url('".$imgname."') top $alignment no-repeat;";
		$return .= "\">$text</span>";
	}
	
	// return the output to the browser
	return $return;
}
?>
